

#include <os.h>
#include <string.h>
#include "math.h"
#include "utils.h"
#include "stringHelper.h"
#include "core.h"

// The longer this is, the less responsive the keys are
#define INPUT_CONTROL 12

void initBaseGUI(int selectedBox, char* scrbuf);
void processOut(int ans[], int ansLen, int lineOut, char output1[]);	// Turns array of ints into string

int main(void)
{
	char *scrbuf = (char*)malloc(SCREEN_BYTES_SIZE);
	memset(scrbuf, 0xFF, SCREEN_BYTES_SIZE);			// Clears crap out of buffer

	initBaseGUI(1, scrbuf);
	refresh(scrbuf);

	// One char for null terminator
	char *input1 = (char*)calloc(2, sizeof(char));
	int inputLen = 0;
	char output1[37];
	// Makes output1 SPACES (not zeroed)
	memset(output1, 32, 37);
	output1[36] = 0;
	//output1 = "Sammy!";
	int operationPos = 0;
	int buttonHelper = INPUT_CONTROL;

	while (!isKeyPressed(KEY_NSPIRE_ESC))
	{
		idle();
		if ((isKeyPressed(KEY_NSPIRE_1) || isKeyPressed(KEY_NSPIRE_2) || isKeyPressed(KEY_NSPIRE_3) || 
			isKeyPressed(KEY_NSPIRE_4) || isKeyPressed(KEY_NSPIRE_5) || isKeyPressed(KEY_NSPIRE_6) || 
			isKeyPressed(KEY_NSPIRE_7) || isKeyPressed(KEY_NSPIRE_8) || isKeyPressed(KEY_NSPIRE_9) || 
			isKeyPressed(KEY_NSPIRE_0)	) && inputLen < 500 && buttonHelper == INPUT_CONTROL)
		{
			if (isKeyPressed(KEY_NSPIRE_1))
				input1[inputLen] = '1';
			if (isKeyPressed(KEY_NSPIRE_2))
				input1[inputLen] = '2';
			if (isKeyPressed(KEY_NSPIRE_3))
				input1[inputLen] = '3';
			if (isKeyPressed(KEY_NSPIRE_4))
				input1[inputLen] = '4';
			if (isKeyPressed(KEY_NSPIRE_5))
				input1[inputLen] = '5';
			if (isKeyPressed(KEY_NSPIRE_6))
				input1[inputLen] = '6';
			if (isKeyPressed(KEY_NSPIRE_7))
				input1[inputLen] = '7';
			if (isKeyPressed(KEY_NSPIRE_8))
				input1[inputLen] = '8';
			if (isKeyPressed(KEY_NSPIRE_9))
				input1[inputLen] = '9';
			if (isKeyPressed(KEY_NSPIRE_0))
				input1[inputLen] = '0';
			inputLen++;
			input1 = realloc(input1, (inputLen + 1) * sizeof(char));

			// Since the newest addition to the string is actually inputLen + 1
			input1[inputLen + 1] = 0;

			buttonHelper = 0;

			clearBuf(scrbuf);
			initBaseGUI(1, scrbuf);
			drawString(input1, 17, 6, scrbuf);
			refresh(scrbuf);
		}

		if (isKeyPressed(KEY_NSPIRE_CLEAR) && buttonHelper == INPUT_CONTROL)
		{
			if (inputLen > 0)
			{
				// Makes output1 SPACES (not zeroed)
				memset(output1, 32, 37);
				output1[36] = 0;

				input1[inputLen - 1] = 0;
				input1[inputLen] = 0;
				inputLen--;

				if (inputLen == operationPos)
					operationPos = 0;
				
				clearBuf(scrbuf);
				initBaseGUI(1, scrbuf);
				if (inputLen > 0)
				{
					drawString(input1, 17, 6, scrbuf);
					input1 = realloc(input1, inputLen * sizeof(char));
				}

				buttonHelper = 0;
				refresh(scrbuf);
			}
		}

		if ((isKeyPressed(KEY_NSPIRE_PLUS) || isKeyPressed(KEY_NSPIRE_MINUS) || isKeyPressed(KEY_NSPIRE_MULTIPLY) || isKeyPressed(KEY_NSPIRE_DIVIDE) ||
			isKeyPressed(KEY_NSPIRE_C) || isKeyPressed(KEY_NSPIRE_F) || isKeyPressed(KEY_NSPIRE_L)|| isKeyPressed(KEY_NSPIRE_M) || isKeyPressed(KEY_NSPIRE_EXP) ||
			isKeyPressed(KEY_NSPIRE_P) || isKeyPressed(KEY_NSPIRE_R) || isKeyPressed(KEY_NSPIRE_S)) && operationPos == 0 && buttonHelper == INPUT_CONTROL)
		{
			if (isKeyPressed(KEY_NSPIRE_PLUS))
				input1[inputLen] = '+';
			if (isKeyPressed(KEY_NSPIRE_MINUS))
				input1[inputLen] = '-';
			if (isKeyPressed(KEY_NSPIRE_MULTIPLY))
				input1[inputLen] = 'x';
			if (isKeyPressed(KEY_NSPIRE_DIVIDE))
				input1[inputLen] = '/';
			if (isKeyPressed(KEY_NSPIRE_C))
				input1[inputLen] = 'C';			// nCr
			if (isKeyPressed(KEY_NSPIRE_F))
				input1[inputLen] = '!';			// Factorial
			if (isKeyPressed(KEY_NSPIRE_M))
				input1[inputLen] = '%';			// Modulus
			if (isKeyPressed(KEY_NSPIRE_P))
				input1[inputLen] = 'P';			// nPr
			if (isKeyPressed(KEY_NSPIRE_R))
				input1[inputLen] = 'R';			// Nth Root
			if (isKeyPressed(KEY_NSPIRE_S))
				input1[inputLen] = 'S';			// Sum of digits
			if (isKeyPressed(KEY_NSPIRE_EXP))
				input1[inputLen] = '^';			// Power
			if (isKeyPressed(KEY_NSPIRE_G))
				input1[inputLen] = 'G';			// GCD
			if (isKeyPressed(KEY_NSPIRE_L))
				input1[inputLen] = 'L';			// LCM
			operationPos = inputLen;
			inputLen++;
			input1 = realloc(input1, (inputLen + 1) * sizeof(char));

			// Since the newest addition to the string is actually inputLen + 1
			input1[inputLen + 1] = 0;

			buttonHelper = 0;

			clearBuf(scrbuf);
			initBaseGUI(1, scrbuf);
			drawString(input1, 17, 6, scrbuf);
			refresh(scrbuf);
		}

		if(isKeyPressed(KEY_NSPIRE_ENTER))
		{
			char operationChar = input1[operationPos];

			// The two input operations
			if ((operationChar == '+' || operationChar == '-' || operationChar == 'x' ||
				operationChar == '/' || operationChar == 'C' || operationChar == '%' || 
				operationChar == 'P' || operationChar == 'R' || operationChar == '^') && buttonHelper == INPUT_CONTROL)
			{
				buttonHelper = 0;

				// Number of ints in each array
				int numInts1 = ceil(operationPos, 4);
				int numInts2 = ceil((inputLen - operationPos - 1), 4);

				int *in1 = (int*)calloc(numInts1, sizeof(int));
				int *in2 = (int*)calloc(numInts2, sizeof(int));

				int currentChar = operationPos - 1;

				for (int i = 0; i < numInts1; i++)
				{
					// One for null termination
					char temp[5];
					temp[3] = input1[currentChar];
					if (currentChar > 0)
						temp[2] = input1[currentChar - 1];
					else
						temp[2] = '0';
					if (currentChar > 1)
						temp[1] = input1[currentChar - 2];
					else
						temp[1] = '0';
					if (currentChar > 2)
					{
						temp[0] = input1[currentChar - 3];
						currentChar = currentChar - 4;
					}
					else
						temp[0] = '0';

					in1[i] = atoi(temp);
				}

				currentChar = inputLen - 1;

				for (int i = 0; i < numInts2; i++)
				{
					// One for null termination
					char temp[5];
					temp[3] = input1[currentChar];
					if (currentChar > operationPos + 1)
						temp[2] = input1[currentChar - 1];
					else
						temp[2] = '0';
					if (currentChar > operationPos + 2)
						temp[1] = input1[currentChar - 2];
					else
						temp[1] = '0';
					if (currentChar > operationPos + 3)
					{
						temp[0] = input1[currentChar - 3];
						currentChar = currentChar - 4;
					}
					else
						temp[0] = '0';

					in2[i] = atoi(temp);
				}

				if (operationChar == '+')
				{
					// First input has to be at least as long as second
					int *ans;
					if (operationPos < inputLen - operationPos - 1)
					{
						ans = (int*)calloc((numInts1 + 1), sizeof(int));
						// Note they are switched around
						numAdd(in2, in1, ans, numInts2, numInts1);
						processOut(ans, numInts2 + 1, 1, output1);
					}
					else
					{
						ans = (int*)calloc((numInts2 + 1), sizeof(int));
						numAdd(in1, in2, ans, numInts1, numInts2);
						processOut(ans, numInts1 + 1, 1, output1);
					}

					drawString(output1, 21, 18, scrbuf);
					refresh(scrbuf);
				}

				if (operationChar == '-')
				{
					// First input has to be at least as long as second
					int *ans;
					if (operationPos < inputLen - operationPos - 1)
					{
						ans = (int*)calloc((numInts1), sizeof(int));
						// Note they are switched around
						numSub(in2, in1, ans, numInts2, numInts1);
						processOut(ans, numInts2 + 1, 1, output1);
					}
					else
					{
						ans = (int*)calloc((numInts2), sizeof(int));
						numSub(in1, in2, ans, numInts1, numInts2);
						processOut(ans, numInts1 + 1, 1, output1);
					}

					drawString(output1, 21, 18, scrbuf);
					refresh(scrbuf);
				}

				if (operationChar == 'x')
				{
					int ansLen;
					int *ans;

					if (operationPos < inputLen - operationPos - 1)
					{
						// Note they are switched around
						ans = numMul(in2, in1, &ansLen, numInts2, numInts1);
					}
					else
					{
						ans = numMul(in1, in2, &ansLen, numInts1, numInts2);
					}

					processOut(ans, numInts1 + numInts2, 1, output1);
					drawString(output1, 21, 18, scrbuf);
					refresh(scrbuf);
				}

				if (operationChar == '^')
				{
					// Just because realloc crashes when ans is null
					int ansLen;
					int *ans;

					// No matter what, the power will be an array of two or one- the Nspire doesn't have enough RAM for more
					// 2^99999999 (highest power possible, lowest output possible) is over 30 million digits, Nspire handles 18 million
					int power;
					if (numInts2 == 1)
						power = in2[0];
					else
						power = in2[1] * 10000 + in2[0];

					ans = fastNumPow(in1, power, &ansLen, numInts1);

					processOut(ans, ansLen, 1, output1);
					drawString(output1, 21, 18, scrbuf);
					refresh(scrbuf);
				}
			}

			// The one input operations, factorial and sum of digits
			else
			{
				// Number of ints in each array
				int numInts1 = ceil(operationPos, 4);
				int currentChar = operationPos - 1;
				int *in1 = (int*)calloc(numInts1, sizeof(int));

				for (int i = 0; i < numInts1; i++)
				{
					// One for null termination
					char temp[5];
					temp[3] = input1[currentChar];
					if (currentChar > 0)
						temp[2] = input1[currentChar - 1];
					else
						temp[2] = '0';
					if (currentChar > 1)
						temp[1] = input1[currentChar - 2];
					else
						temp[1] = '0';
					if (currentChar > 2)
					{
						temp[0] = input1[currentChar - 3];
						currentChar = currentChar - 4;
					}
					else
						temp[0] = '0';

					in1[i] = atoi(temp);
				}

				if (operationChar == 'S')
				{
					int sumLen;
					int *sum = numSum(in1, numInts1, &sumLen);
					processOut(sum, sumLen, 1, output1);
					drawString(output1, 21, 18, scrbuf);
					refresh(scrbuf);
				}
			}
		}

		if (buttonHelper < INPUT_CONTROL)
			buttonHelper++;
	}

	free(input1);
	free(scrbuf);
	return 0;
} 

void initBaseGUI(int selectedBox, char* scrbuf)
{
	// The lines that separate each input panel and also
	// the vertical one that separates the numbers from the input
	drawHorLine(0, 30, 319, scrbuf);
	drawHorLine(0, 60, 319, scrbuf);
	drawHorLine(0, 90, 319, scrbuf);
	drawHorLine(0, 120, 319, scrbuf);
	drawHorLine(0, 150, 319, scrbuf);
	drawHorLine(0, 180, 319, scrbuf);
	drawHorLine(0, 210, 319, scrbuf);
	drawVerLine(14, 0, 210, scrbuf);

	// Draws first bottom box
	drawHorLine(0, 213, 206, scrbuf);
	drawVerLine(206, 213, 27, scrbuf);
	// Draws second bottom box
	drawHorLine(209, 213, 110, scrbuf);
	drawVerLine(209, 213, 27, scrbuf);	// IDK why but these weird coordinates make the line pixel perfect

	// Draws rectangle showing which box is selected
	fill(0, 0, 14, 30, 11, scrbuf);

	// Numbers on sides of input lines
	drawString("A", 3, 10, scrbuf);
	drawString("B", 3, 40, scrbuf);
	drawString("C", 3, 70, scrbuf);
	drawString("D", 3, 100, scrbuf);
	drawString("E", 3, 130, scrbuf);
	drawString("F", 3, 160, scrbuf);
	drawString("G", 3, 190, scrbuf);

	// Text in the two bottom boxes
	drawString("BigNumNum Cruncher v0.17a", 3, 220, scrbuf);
	drawString("By Philip Sun", 213, 220, scrbuf);

	// Test - array fails at around 18750000
	//char *test = calloc(1, sizeof(char));
	//int maxLength = 1;
	//int stop = 0;
	//while (stop == 0)
	//{
	//	maxLength++;
	//	test = realloc(test, maxLength * sizeof(char));
	//	if (test == 0)
	//		stop = 1;
	//}

	//char temp[7];
	//memset(temp, 0, 7);
	//itoa(temp, maxLength, 10);
	//drawString(temp, 50, 50, scrbuf);

	//free(test);
}

void processOut(int ans[], int ansLen, int lineOut, char output1[])
{
	// The number of ints in the end of the array that are null
	int nullInts = 0;
	for (int i = ansLen - 1; i >= 0; i--)
	{
		if (ans[i] == 0)
				nullInts++;
		else
			break;
	}

	// The output can show 36 digits
	if (ansLen - nullInts < 10)
	{
		// Last character in array (other than null terminator)
		int currentChar = 35;

		for (int i = 0; i < ansLen - nullInts; i++)
		{
			char temp[5];
			memset(temp, 0, 5);
			itoa(temp, ans[i], 10);

			while(temp[3] == 0)
			{
				temp[3] = temp[2];
				temp[2] = temp[1];
				temp[1] = temp[0];

				// The end value of i is ansLen - nullInts - 1
				if (i == ansLen - nullInts - 1)
					temp[0] = ' ';
				else
					temp[0] = '0';
			}

			output1[currentChar] = temp[3];
			output1[currentChar - 1] = temp[2];
			output1[currentChar - 2] = temp[1];
			output1[currentChar - 3] = temp[0];

			currentChar = currentChar - 4;
		}
	}
	else
	{
		// Last character in array (other than null terminator)
		// Different from standard input because of the ...
		int currentChar = 34;

		// For the last eight digits
		for (int i = 0; i < 2; i++)
		{
			char temp[5];
			memset(temp, 0, 5);
			itoa(temp, ans[i], 10);

			while(temp[3] == 0)
			{
				temp[3] = temp[2];
				temp[2] = temp[1];
				temp[1] = temp[0];
				temp[0] = '0';
			}

			output1[currentChar] = temp[3];
			output1[currentChar - 1] = temp[2];
			output1[currentChar - 2] = temp[1];
			output1[currentChar - 3] = temp[0];

			currentChar = currentChar - 4;
		}

		output1[26] = '.';
		output1[25] = '.';
		output1[24] = '.';

		currentChar = 23;

		for (int i = ansLen - nullInts - 6; i < ansLen - nullInts; i++)
		{
			char temp[5];
				memset(temp, 0, 5);
				itoa(temp, ans[i], 10);

				while(temp[3] == 0)
				{
					temp[3] = temp[2];
					temp[2] = temp[1];
					temp[1] = temp[0];

					// The end value of i is ansLen - nullInts - 1
					if (i == ansLen - nullInts - 1)
						temp[0] = ' ';
					else
						temp[0] = '0';
				}

				output1[currentChar] = temp[3];
				output1[currentChar - 1] = temp[2];
				output1[currentChar - 2] = temp[1];
				output1[currentChar - 3] = temp[0];

				currentChar = currentChar - 4;
		}
	}
}
